
var defaultValue=new Object(); 
var shiftValue=new Object(); 
var altValue=new Object();
var longTouchValue=new Object();
var idOfAttachedInput;
var focusGetter;
var isAKeyboardAlreadyOpen=false;
var toggleKeys=new Object();
var longPressTimer;
var usedSubKeys=false;
var isSubKeysVisible=false;

var previousXDialog=0;
var previousYDialog=0;

var theCurrentKeyboard;
var nbKeyboardTotal=0;

$.fx.speeds._default =250;


function initialiseAll(){
	 defaultValue=new Object(); 
	 shiftValue=new Object(); 
	 altValue=new Object();
	 longTouchValue=new Object();
	 idOfAttachedInput="undefined";
	 focusGetter="undefined";
	 isAKeyboardAlreadyOpen=false;
	 toggleKeys=new Object();
	 longPressTimer="undefined";
	 usedSubKeys=false;
	 $("#theKeyBoard").remove();
	 $("#longTouchRow").remove();
	 nbKeyboardTotal=0;
}
function createDialog(){
$( "#dialog" ).dialog({
		autoOpen: false,
		//open: function(event, ui) { 
	//$('#messages').text("table width : "+$('#keyboardTable').width());
	//$('#dialog').dialog( "option" , "width", $('#keyboardTable').width()+20);
			//	},
		position: [$(idOfAttachedInput).offset().left,$(idOfAttachedInput).offset().top+$(idOfAttachedInput).height()],
		show: "fade",
		hide: "fade",
		width: 'auto',
		drag: function(event,ui){
				
				moveSubKeys();
			},
		
		
		beforeClose: function(event, ui) {$("#longTouchRow").remove();},
		close: function() {  $('#theKeyBoard').remove(); isAKeyboardAlreadyOpen=false;  $( "#dialog" ).dialog("destroy"); initialiseAll();}
	});

}

function moveSubKeys(){
	
	if(isSubKeysVisible){	
		setSubkeysPosition($("#longTouchRow"));
	}
	
}

function getInnerElementFromDHTMLXTouch(idOfTheView){
	
}

function showKeyBoard(id/*theInput,typeOfKeyboard*/){
	
	//$('div[view_id='+id+']').children("div").children("textarea").attr("id","testClacierIdTextarea");
	var theInput=$('div[view_id='+id+']').children("div").children("textarea");
	theInput.attr("id","testClacierIdTextarea");
	alert($(theInput).attr("id"));
	//theInput=theInput.split(".")[0];
	//alert(theInput.attr("class"));
	
	if( theInput != idOfAttachedInput){
		
		//$("#messages").text("chang clavier");
		initialiseAll();
		idOfAttachedInput=theInput;
		createDialog();
		$( theInput ).autocomplete({
			source: availableTags
		});
		
		isAKeyboardAlreadyOpen=true;
		getXMLFileForAllKeyboard("layoutAlphaNumeric.xml");
		//getXMLFile(typeOfKeyboard);
	}
}
function showKeyBoardClassic(theInput,typeOfKeyboard){
	
	
	
	if( theInput != idOfAttachedInput){
		
		//$("#messages").text("chang clavier");
		initialiseAll();
		idOfAttachedInput=theInput;
		createDialog();
		$( theInput ).autocomplete({
			source: availableTags
		});
		
		isAKeyboardAlreadyOpen=true;
		getXMLFileForAllKeyboard(typeOfKeyboard);
		//getXMLFile(typeOfKeyboard);
	}
}
function getXMLFileForAllKeyboard(layoutFile){
	  $.ajax({
	    type: "GET",
	   
	   url: "clavier/data/"+layoutFile,
	    dataType: "xml",
	    success: buildAllTheKeyboard
	  });
	}
function getXMLFile(typeOfKeyboard){
  $.ajax({
    type: "GET",
    async:false,
   url: "clavier/data/"+typeOfKeyboard,
    dataType: "xml",
    success: buildOneKeyboard
  });
}


function getAlternative(theKey,theKeyValue){
	theKey.find("alternative").each(function(){
		var kindOfFlag=$(this).attr('flag');
		if(kindOfFlag == "SHIFT"){
			var theChar=$(this).attr('value');
			shiftValue[getTheRightcharFromUnicode(theKeyValue)]=getTheRightcharFromUnicode($(this).attr('value'));
		}
		else if(kindOfFlag == "ALT"){
			altValue[getTheRightcharFromUnicode(theKeyValue)]=getTheRightcharFromUnicode($(this).attr('value'));
		}
		else if(kindOfFlag == "touch"){
			var allSubKeyForThiskey=new Array();
			theKey.find("subKey").each(function(){
				allSubKeyForThiskey[allSubKeyForThiskey.length]=getTheRightcharFromUnicode($(this).attr('value'));
			});
			longTouchValue[getTheRightcharFromUnicode(theKeyValue)]=allSubKeyForThiskey;
		}
	});
}
function buildAllTheKeyboard(xml){
	
	var theMainLayout=$('<div id="theKeyBoard"/>');
	var theTable=$('<table id="keyboardTable"/>');
	theTable.appendTo(theMainLayout);
	//var nbKeyboard=0;
	$(xml).find("tr").each(function(){
		
		var theTR=$('<tr/>');
		theTR.appendTo(theTable);
		$(this).find("td").each(function(){
			nbKeyboardTotal++;
			var theCurrentTD=$('<td/>').css({'padding-top':'0px', 'vertical-align': 'top','text-align':'left'});
			theCurrentTD.attr("rowspan",$(this).attr('rowLength'));
			theCurrentTD.attr("colspan",$(this).attr('colLength'));
			theCurrentTD.appendTo(theTR);
			var theTypeOfKeyboard=$(this).attr('keyboardData');
			theCurrentKeyboard=$('<div id="keyboard'+nbKeyboardTotal+'"/>');
			theCurrentKeyboard.appendTo(theCurrentTD);
			//$('#messages').text(theTypeOfKeyboard);
			getXMLFile(theTypeOfKeyboard);	
		});
		
		
	});
	
	theMainLayout.appendTo('#dialog');
	
	
	
	
	$( ".keyboardPressKey" ).button();//pour associer le css au touches du clavier que l'on viens de creer
	$( ".backspace").button({
        icons: {
        primary: "ui-icon-arrowthick-1-w"
		},
		text: false
	});
	$( ".keyboardToggleTouch" ).button();
	
	
	$( "#dialog" ).dialog("open");
}
function buildOneKeyboard(xml){
	//var theKeyboardBody=$('<div id="theKeyBoard"/>'); //-->to be replaced by mainLayout
 
	var rowCount=0;
	var keyCount=0;
	//nbKeyboardTotal++;
	var thekeyboardTable=$('<table id="specificKeyboardTable'+nbKeyboardTotal+'"+/>').appendTo(theCurrentKeyboard);
	//var
	$(xml).find("keyRow").each(function(){
		var specificKeyboardTR=$('<tr/>');
		specificKeyboardTR.appendTo(thekeyboardTable);
		rowCount++;
		//var theCurrentRow=$('<div id="keyboard'+nbKeyboardTotal+'row'+rowCount+'"/>').addClass("keyboardRow").css({'text-align' : 'center', 'margin-top':'4px'}).appendTo(theCurrentKeyboard/*'#theKeyBoard'*/);//CSS : centre tous les div de la ligne(centre la div ligne)
		
		$(this).find("key").each(function(){
			var theCurrentRow=$('<td id="keyboard'+nbKeyboardTotal+'row'+rowCount+'"/>').addClass("keyboardRow").appendTo(specificKeyboardTR);;
			var colspanData=$(this).attr("colspan");
			var rowspanData=$(this).attr("rowspan");
			if(colspanData != "undefined"){
				theCurrentRow.attr("colspan",colspanData);
			}
			if(rowspanData != "undefined"){
				theCurrentRow.attr("rowspan",rowspanData);
			}
			var theActualKey=$(this).attr('value');
			var keyType=$(this).attr('type');
			getAlternative($(this),theActualKey);
			buildPressKey(keyType,theActualKey,keyCount,rowCount,theCurrentRow);
			buildToggleKey(keyType,theActualKey,keyCount,rowCount,theCurrentRow);		
			keyCount++;
		});
		
		
	});
	/*$( ".keyboardPressKey" ).button();//pour associer le css aux touches du clavier que l'on viens de creer
	$( ".backspace").button({
        icons: {
        primary: "ui-icon-arrowthick-1-w"
		},
		text: false
	});
	$( ".keyboardToggleTouch" ).button();*/
	//theKeyboardBody.appendTo(theCurrentTD);
	
	
}
/*
function buildOneKeyboard(xml){
	
	var theKeyboardBody=$('<div id="theKeyBoard"/>'); //-->to be replaced by mainLayout
 
	var rowCount=0;
	var keyCount=0;
	$(xml).find("keyRow").each(function(){
		rowCount++;
		var theCurrentRow=$('<div id="row'+rowCount+'"/>').addClass("keyboardRow").css({'text-align' : 'center', 'margin-top':'4px'}).appendTo(theKeyboardBody);//CSS : centre tous les div de la ligne(centre la div ligne)
		
		$(this).find("key").each(function(){
			var theActualKey=$(this).attr('value');
			var keyType=$(this).attr('type');
			getAlternative($(this),theActualKey);
			buildPressKey(keyType,theActualKey,keyCount,rowCount,theCurrentRow);
			buildToggleKey(keyType,theActualKey,keyCount,rowCount,theCurrentRow);		
			keyCount++;
		});
		
		
	});
	theKeyboardBody.appendTo('#dialog');
	//showGottenData();
	$( "#dialog" ).dialog("open");
	$( ".keyboardPressKey" ).button();//pour associer le css au touches du clavier que l'on viens de creer
	$( "#backspace").button({
        icons: {
        primary: "ui-icon-arrowthick-1-w"
    	},
    	text: false
	});
	$( ".keyboardToggleTouch" ).button();
}*/

function getTheRightChar(theClickedKey){
	for( key in toggleKeys){
		if(toggleKeys[key]){
			
			if(key=="shift"){
				if(typeof(shiftValue[theClickedKey])!="undefined"){
					$("#messages2").text("shift : "+theClickedKey);
					return shiftValue[theClickedKey];
				}
				else{
					$("#messages2").text("shift undef: "+theClickedKey);
					return theClickedKey;
				}
			}
			else if(key=="alt"){
				if(typeof(altValue[theClickedKey])!="undefined"){
					$("#messages2").text("alt : "+theClickedKey);
					return altValue[theClickedKey];
				}
				else{
					$("#messages2").text("alt undef : "+theClickedKey);
					return theClickedKey;
				}
			}
		}
	}
	$("#messages2").text(theClickedKey);
	return theClickedKey;
	//return defaultValue[keyNumber];
}

function updateKeyLabel(){
	for(key in defaultValue){
		$($("#"+key).children("span")[0]).text(getTheRightChar(defaultValue[key]));
	}
}

function getTheRightcharFromUnicode(unicodeOrNot){
	var regularExpForUnicode=/[Uu]\+([A-Fa-f0-9]{4})/gi;
	if (unicodeOrNot.match(regularExpForUnicode)) {
		unicodeOrNot=convertUnicode2Char(unicodeOrNot);
	 }
	return unicodeOrNot;
}

/*standard key and space key*/
function buildPressKey(keyType,theActualKeyValue,keyCount,rowCount,theCurrentRow){
	
	var theButtonDiv;
	if( keyType == "press"){

		theActualKeyValue=getTheRightcharFromUnicode(theActualKeyValue);
		defaultValue["keyboard"+nbKeyboardTotal+"key"+keyCount]=theActualKeyValue;
		theButtonDiv=$('<div id="keyboard'+nbKeyboardTotal+'key'+keyCount+'"/>');
		theButtonDiv.css({'height': '2.3em', 'width': '2.3em', 'margin': '.1em', 'cursor': 'pointer', 'overflow': 'hidden'});
		theButtonDiv.append($('<span>')).text(theActualKeyValue);
		
		bindKeyboardKeyPressEvent(theButtonDiv,theActualKeyValue,false);
		theButtonDiv.addClass("keyboardPressKey");
		theButtonDiv.css({/*display:'inline-block',*/'margin-left':'4px'}).appendTo(theCurrentRow/*"#row"+rowCount*/);
	}
	else if(keyType == "spacebar"){
		theButtonDiv=$('<div id="keyspacebar"/>').css({'width': '15em','text-indent': '-999em'});
		theButtonDiv.append($('<span>')).text('space');
		theButtonDiv.addClass("keyboardPressKey");
		bindKeyboardKeyPressEvent(theButtonDiv,theActualKeyValue,false);
		theCurrentRow.attr("colspan","5");
		theButtonDiv.css({ 'margin-left':'4px'}).appendTo(/*"#row"+rowCount*/theCurrentRow);
	}
	else if(keyType == "backspace"){
		theButtonDiv=$('<div class="backspace"/>');
		theButtonDiv.append($('<span>')).text('Bksp');
		theButtonDiv.css({'height': '2.3em', 'width': '2.3em', 'margin': '.1em', 'cursor': 'pointer', 'overflow': 'hidden'});
		
		bindKeyboardKeyPressEvent(theButtonDiv,"",true);
		theButtonDiv.css({/*display:'inline-block',*/ 'margin-left':'4px'}).appendTo(theCurrentRow/*"#row"+rowCount*/);
	}
	
}

/*toggle key*/
function buildToggleKey(keyType,theActualKey,keyCount,rowCount,theCurrentRow){
	var theButtonDiv;
	var theInput;
	var theLabel;
	if(keyType == "toggle" && typeof(toggleKeys[theActualKey])=="undefined"){
		theCurrentRow.attr("colspan","2");
		addNewToggleKey(theActualKey);
		theButtonDiv=$('<div id="keyboard'+nbKeyboardTotal+'key'+keyCount+'"/>');
		theInput=$('<input type="checkbox" id="keyboard'+nbKeyboardTotal+theActualKey+keyCount+'"/>');
		
		theLabel=($('<label for="keyboard'+nbKeyboardTotal+theActualKey+keyCount+'">')).text(theActualKey);
		theLabel.addClass(theActualKey+keyCount);
		theLabel.css({'height': '2.3em', 'width': '5em', 'margin': '.1em', 'cursor': 'pointer', 'overflow': 'hidden'});
		
		theInput.addClass("keyboardToggleTouch");
		theButtonDiv.append(theInput);
		theButtonDiv.append(theLabel);
		//theButtonDiv.css({'height': '2.3em', 'width': '200px', 'margin': '.1em', 'cursor': 'pointer', 'overflow': 'hidden'});
		theButtonDiv/*.css({ 'margin-left':'4px','width': 'auto'})*/.appendTo(theCurrentRow/*"#row"+rowCount*/);
		//theButtonDiv.css({'height': '2.3em', 'width': '2.3em', 'margin': '.1em', 'cursor': 'pointer', 'overflow': 'hidden'}).appendTo(theCurrentRow/*"#row"+rowCount*/);
		bindKeyboardTogglePressEvent(theButtonDiv,theActualKey);
	}
	
}

function addNewToggleKey(theNewKey){
	if(typeof(toggleKeys[theNewKey])=="undefined"){
		toggleKeys[theNewKey]=false;
	}
}

function bindKeyboardKeyPressEvent(theButtonDiv,theActualKey,bkspKey){
	theButtonDiv.bind({
		click: function(){
			if(!usedSubKeys){
				var theActualKeyTemp=getTheRightChar(theActualKey);
				
				var contentLength=$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).val().length;
				var caretPosition=$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).getSelection().start;
				var caretEndPosition=$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).getSelection().end;
				if(bkspKey){
					var contentBegin=$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).val().substring(0,caretPosition-1);
				}
				else{
					var contentBegin=$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).val().substring(0,caretPosition);
				}
				
				var contentEnd=$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).val().substring(caretPosition,contentLength);
				var newContent=contentBegin+theActualKeyTemp+contentEnd;  
				if(!bkspKey){
					var newCaretPosition=caretPosition+theActualKeyTemp.length+1;	
				}
				else{
					var newCaretPosition=caretPosition+theActualKeyTemp.length;	
				}
				updateInputContent(caretPosition,caretEndPosition,theActualKeyTemp,newContent,newCaretPosition);
				$(idOfAttachedInput).autocomplete( "search" , newContent);
				//$("#messages").text(newContent);
				$("#longTouchRow").remove();
				isSubKeysVisible=false;
			}
			else{
				usedSubKeys=false;
			}
		   
	  	},
	  	mousedown: function(e){
	  		longPressTimer = window.setTimeout(function() { 
	  			usedSubKeys=showAlternativeKeys(theActualKey);  },700);
	  			
	  	},
	  	mouseup: function(){
	  		clearTimeout(longPressTimer);
		  }
		});

}

function getDialogPosition(){
	var position=new Array($("#dialog").offset().left,$("#dialog").offset().top);
	//$("#messages").text("dialog x : "+$("#dialog").offset().left+" dialog y : "+$("#dialog").offset().top);
	return position;
}
function setSubkeysPosition(theRow){
	var dialogXY=getDialogPosition();
	var theRowWidth=theRow.width();
	var theDialogWidth=$("#dialog").width();
	var theRightX=Math.round(theDialogWidth/2 - theRowWidth/2 + dialogXY[0] + 4);
	theRow.offset({ top: dialogXY[1]-46-theRow.height(), left: theRightX });
}

function showAlternativeKeys(theActualKey){
	var listOfLongTouchKeys=longTouchValue[theActualKey];
	if(typeof(listOfLongTouchKeys)!="undefined" && !isSubKeysVisible){
		var theRow= $('<div id="longTouchRow"/>').addClass("keyboardRow")
		.css({	position: 'absolute',
				'text-align' : 'center', 
				'background-color':'white',
				'padding':'3px',
				zIndex:2000}).appendTo('body');
		var theButtonDiv;
		var i=1;
		for(key in listOfLongTouchKeys){
			theButtonDiv=$('<div id="longTouchKey'+i+'"/>');
			theButtonDiv.css({'height': '2.3em', 'width': '2.3em', 'margin': '.1em', 'cursor': 'pointer', 'overflow': 'hidden'});
			theButtonDiv.append($('<span>')).text(listOfLongTouchKeys[key]);
			
			bindKeyboardKeyPressEvent(theButtonDiv,listOfLongTouchKeys[key],false);
			theButtonDiv.addClass("keyboardPressKey");
			theButtonDiv.appendTo(theRow);
			i++;
		}
		createCloseButton(theRow);
		theRow.appendTo('body');
		
		$( ".keyboardPressKey" ).button();
		setSubkeysPosition($("#longTouchRow"));
		isSubKeysVisible=true;
		
		return true;
	}
	return false;
	//theRow.appendTo('body');
	
}
function createCloseButton(theRow){
	var theButtonDiv;
	theButtonDiv=$('<div id="closeSubkeysList"/>');
	theButtonDiv.append($('<span>')).text('close');
	theButtonDiv.css({'height': '2.3em', 'width': '2.3em', 'margin': '.1em', 'cursor': 'pointer', 'overflow': 'hidden'});
	theButtonDiv.button({
        icons: {
        primary: "ui-icon-closethick"
    },
    text: false
	});
	theButtonDiv.bind('click', function() {
		isSubKeysVisible=false;
		 $("#longTouchRow").remove();
	});
	theButtonDiv.appendTo(theRow);
}

function afficherToggleFunc(tab){
	var chaine="";
	for( v in tab){
		chaine=chaine+v+" : "+tab[v]+" ";
	}
	return chaine;
}

function bindKeyboardTogglePressEvent(theButtonDiv,typeOfToggleKey){
	theButtonDiv.bind({
		click: function(event){
		if(event.target.tagName == "SPAN"){
		var classOfClickedToggle=theButtonDiv.children("input").attr("id");
		var $toggle = $("#"+classOfClickedToggle);
		toggleKeys[typeOfToggleKey]=!$toggle.attr("checked");
		disableOtherToggleKeys(typeOfToggleKey);
		updateKeyLabel();
		
		}
	  	}
	  	
		});
	
}
function disableOtherToggleKeys(activeOne){
	for(key in toggleKeys){
		if(toggleKeys[key] && key != activeOne){
			 var listOfOtherToggleKeys=$('input:regex(id,'+key+'[0-9])');
			 for(var i=0;i<listOfOtherToggleKeys.length;i++){
				 var $toggle = $(listOfOtherToggleKeys[i]);
					toggleKeys[key]=!$toggle.attr("checked");
					$toggle.attr("checked", !$toggle.attr("checked")).button("refresh");	
			 }
		}
	}
}

jQuery.expr[':'].regex = function(elem, index, match) {
	   var matchParams = match[3].split(','),
	       validLabels = /^(data|css):/,
	       attr = {
	           method: matchParams[0].match(validLabels) ? 
	                       matchParams[0].split(':')[0] : 'attr',
	           property: matchParams.shift().replace(validLabels,'')
	       },
	       regexFlags = 'ig',
	       regex = new RegExp(matchParams.join('').replace(/^\s+|\s+$/g,''), regexFlags);
	   return regex.test(jQuery(elem)[attr.method](attr.property));
	};
/*
(function( $ ){
	  $.fn.setCursorPosition = function(pos) {
	    if ($(this).get(0).setSelectionRange) {
	      $(this).get(0).setSelectionRange(pos, pos);
	    } else if ($(this).get(0).createTextRange) {
	      var range = $(this).get(0).createTextRange();
	      range.collapse(true);
	      range.moveEnd('character', pos);
	      range.moveStart('character', pos);
	      range.select();
	    }
	    
	  };
	})(jQuery);*/
function updateInputContent(theStart,theEnd,thePressedKey,theNewContent,theNewCaretPosition){
	if(theStart != theEnd){
		$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).replaceSelection(thePressedKey);
	}
	else{
		$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).val(theNewContent);
		$(/*":input[name="+*/idOfAttachedInput/*.name+"]"*/).setCaretPos(theNewCaretPosition);
	}
}
function getBackTheFocus(){
	focusGetter=setInterval(function(){idOfAttachedInput.focus(); }, 1);
}
function destroyTheFocus(){
	clearInterval(focusGetter);
}	

(function( $ ){
$.fn.putCursorAtEnd = function()
{
    return this.each(function()
    {
        $(this).focus();

        // If this function exists...
        if (this.setSelectionRange)
        {
            // ... then use it
            // (Doesn't work in IE)

            // Double the length because Opera is inconsistent about whether a carriage return is one character or two. Sigh.
            var len = $(this).val().length * 2;
            this.setSelectionRange(len, len);
        }
        else
        {
            // ... otherwise replace the contents with itself
            // (Doesn't work in Google Chrome)
            $(this).val($(this).val());
        }

        // Scroll to the bottom, in case we're in a tall textarea
        // (Necessary for Firefox and Google Chrome)
        this.scrollTop = 999999;
    });
};
})(jQuery);

/*Unicode conversion ==============================================================*/
function convertUnicode2Char ( str ) { 
	//conversion des caractres unicodes a 6 caractres
	str = str.replace(/[Uu]\+10([A-Fa-f0-9]{4})/g, 
					function(matchstr, parens) {
						return hex2char('10'+parens);
					}
						); 
	//conversion des caractres unicodes a 5 caractres
	str = str.replace(/[Uu]\+([A-Fa-f0-9]{1,5})/g, 
					function(matchstr, parens) {
						return hex2char(parens);
					}
						); 
	return str;
	}

function hex2char ( hex ) {
	
	var result = '';
	var n = parseInt(hex, 16);
    if (n <= 0xFFFF) { result += String.fromCharCode(n); } 
	else if (n <= 0x10FFFF) {
		n -= 0x10000;
		result += String.fromCharCode(0xD800 | (n >> 10)) + String.fromCharCode(0xDC00 | (n & 0x3FF));
    	} 
	else { result += 'X'; }
	return result;
	}



/*=====================================================================================================*/

/*=====================================================================================================*/

